diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
index 191b5727d..4122b4bc5 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
@@ -1,96 +1,203 @@
-package net.minecraft.core.world.generate.chunk.perlin.nether;
-
-import net.minecraft.core.block.BlockLogicSand;
-import net.minecraft.core.block.Blocks;
-import net.minecraft.core.world.World;
-import net.minecraft.core.world.chunk.Chunk;
-import net.minecraft.core.world.generate.chunk.ChunkDecorator;
-import net.minecraft.core.world.generate.feature.*;
-
-import java.util.Random;
-
-public class ChunkDecoratorNether
-    implements ChunkDecorator
-{
-    private final World world;
-
-    public ChunkDecoratorNether(World world)
-    {
-        this.world = world;
-    }
-
-    @Override
-    public void decorate(Chunk chunk)
-    {
-        int chunkX = chunk.xPosition;
-        int chunkZ = chunk.zPosition;
-
-        int minY = world.getWorldType().getMinY();
-        int maxY = world.getWorldType().getMaxY();
-        int rangeY = (maxY + 1) - minY;
-
-        Random rand = new Random((long) chunkX * 0x4f9939f508L + (long) chunkZ * 0x1ef1565bd5L);
-
-        BlockLogicSand.fallInstantly = true;
-        int x = chunkX * 16;
-        int z = chunkZ * 16;
-        for(int i = 0; i < 8; i++)
-        {
-            int xf = x + rand.nextInt(16) + 8;
-            int yf = minY + rand.nextInt(rangeY - 8) + 4;
-            int zf = z + rand.nextInt(16) + 8;
-            new WorldFeatureNetherLava(Blocks.FLUID_LAVA_FLOWING.id()).place(world, rand, xf, yf, zf);
-        }
-
-        for(int i = 0; i < 10; i++)
-        {
-            int xf = x + rand.nextInt(16);
-            int yf = minY + rand.nextInt(rangeY - 8) + 4;
-            int zf = z + rand.nextInt(16);
-            new WorldFeatureOre(Blocks.ORE_NETHERCOAL_NETHERRACK.id(), 12).place(world, rand, xf, yf, zf);
-        }
-
-        int max = rand.nextInt(rand.nextInt(10) + 1);
-        for(int i = 0; i < max; i++)
-        {
-            int xf = x + rand.nextInt(16) + 8;
-            int yf = minY + rand.nextInt(rangeY - 8) + 4;
-            int zf = z + rand.nextInt(16) + 8;
-            new WorldFeatureFire().place(world, rand, xf, yf, zf);
-        }
-
-        max = rand.nextInt(rand.nextInt(10) + 1);
-        for(int i = 0; i < max; i++)
-        {
-            int xf = x + rand.nextInt(16) + 8;
-            int yf = minY + rand.nextInt(rangeY - 8) + 4;
-            int zf = z + rand.nextInt(16) + 8;
-            new WorldFeatureGlowstoneA().place(world, rand, xf, yf, zf);
-        }
-
-        for(int i = 0; i < 10; i++)
-        {
-            int xf = x + rand.nextInt(16) + 8;
-            int yf = minY + rand.nextInt(rangeY - 8) + 4;
-            int zf = z + rand.nextInt(16) + 8;
-            new WorldFeatureGlowstoneB().place(world, rand, xf, yf, zf);
-        }
-
-        if (rand.nextInt(8) == 0) {
-            int xf = x + rand.nextInt(16) + 8;
-            int yf = minY + rand.nextInt(rangeY - 16) + 8;
-            int zf = z + rand.nextInt(16) + 8;
-            new WorldFeatureLake(Blocks.FLUID_LAVA_STILL.id()).place(world, rand, xf, yf, zf);
-        }
-
-        for (int i = 0; i < /*20*/80; i++) {
-            int xf = x + rand.nextInt(16);
-            int yf = minY + rand.nextInt(rangeY);
-            int zf = z + rand.nextInt(16);
-            new WorldFeaturePumice(32).place(world, rand, xf, yf, zf);
-        }
-
-        BlockLogicSand.fallInstantly = false;
-
-    }
-}
+package net.minecraft.core.world.generate.chunk.perlin.nether;
+
+import net.minecraft.core.block.BlockLogicSand;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.generate.chunk.ChunkDecorator;
+import net.minecraft.core.world.generate.feature.*;
+import net.minecraft.core.world.noise.PerlinNoise;
+
+import java.util.Random;
+
+public class ChunkDecoratorNether
+    implements ChunkDecorator
+{
+    private final World world;
+    private final PerlinNoise crystalDensityNoise;
+
+    public ChunkDecoratorNether(World world)
+    {
+        this.world = world;
+        crystalDensityNoise = new PerlinNoise(world.getRandomSeed(), 6, 74);
+    }
+
+    @Override
+    public void decorate(Chunk chunk)
+    {
+        int chunkX = chunk.xPosition;
+        int chunkZ = chunk.zPosition;
+
+        int minY = world.getWorldType().getMinY();
+        int maxY = world.getWorldType().getMaxY();
+        int rangeY = (maxY + 1) - minY;
+
+        Random rand = new Random((long) chunkX * 0x4f9939f508L + (long) chunkZ * 0x1ef1565bd5L);
+
+        BlockLogicSand.fallInstantly = true;
+        int x = chunkX * 16;
+        int z = chunkZ * 16;
+        Biome biome = world.getBlockBiome(x + 16, minY, z + 16);
+
+        if (biome == Biomes.NETHER_CRYSTAL_FOREST) {
+            double noiseScale = 0.5;
+
+            int density = (int) ((crystalDensityNoise.get(x * noiseScale, z * noiseScale) - 6D + 36D) / 6D);
+
+            for (int i = 0; i < density - 5; i++) {
+                int xf = x + rand.nextInt(16) + 8;
+                int yf = world.getWorldType().getOceanY() + rand.nextInt(5);
+                int zf = z + rand.nextInt(16) + 8;
+                boolean isCeiling = rand.nextInt(5) == 0;
+                new WorldFeatureCrystalChunk(isCeiling).place(world, rand, xf, yf, zf);
+            }
+
+
+            for (int i = 0; i < density - 5; i++) {
+                int xf = x + rand.nextInt(16) + 8;
+                int yf = world.getWorldType().getOceanY() + rand.nextInt(rangeY - 8) + 4;
+                int zf = z + rand.nextInt(16) + 8;
+                new WorldFeatureCrystalChunk(false, 15, 30, true).place(world, rand, xf, yf, zf);
+
+            }
+
+            for (int i = 0; i < 40; i++) {
+                int xf = x + rand.nextInt(16) + 8;
+                int yf = world.getWorldType().getOceanY() + rand.nextInt(rangeY - 8) + 4;
+                int zf = z + rand.nextInt(16) + 8;
+                (new WorldFeatureDeadBush(Blocks.CRYSTAL_STALK.id())).place(world, rand, xf, yf, zf);
+            }
+
+            for(int l18 = 0; l18 < 50; l18++)
+            {
+                int l21 = x + rand.nextInt(16) + 8;
+                int k23 = minY + rand.nextInt(rand.nextInt(rangeY - (rangeY / 16)) + (rangeY / 16));
+                int l24 = z + rand.nextInt(16) + 8;
+                (new WorldFeatureLiquid(Blocks.FLUID_WATER_FLOWING.id())).place(world, rand, l21, k23, l24);
+            }
+
+        }
+//
+//        if (biome == Biomes.NETHER_SULFUR_POOLS) {
+//            for (int i = 0; i < 2; i++) {
+//                int xf = x + rand.nextInt(16) + 8;
+//                int yf = world.getWorldType().getOceanY() + rand.nextInt(rangeY - 8) + 4;
+//                int zf = z + rand.nextInt(16) + 8;
+//                new WorldFeaturePillar(Blocks.COBBLE_NETHERRACK.id, true).place(world, rand, xf, yf, zf);
+//            }
+//        }
+
+        if (biome == Biomes.NETHER_ASH_PLAINS) {
+            if (rand.nextInt(2) == 0) {
+                int xf = x + rand.nextInt(16) + 8;
+                int yf = world.getWorldType().getOceanY() + rand.nextInt(rangeY - 8) + 4;
+                int zf = z + rand.nextInt(16) + 8;
+                new WorldFeaturePillar(Blocks.SLATE.id(), false).place(world, rand, xf, yf, zf);
+            }
+        }
+
+        if (biome != Biomes.NETHER_ASH_PLAINS && biome != Biomes.NETHER_BONEYARD) {
+            for(int i = 0; i < 8; i++)
+            {
+                int xf = x + rand.nextInt(16) + 8;
+                int yf = rangeY / 2 + rand.nextInt(rangeY - 8) + 4;
+                int zf = z + rand.nextInt(16) + 8;
+                (new WorldFeatureNetherLava(Blocks.FLUID_LAVA_FLOWING.id())).place(world, rand, xf, yf, zf);
+            }
+        }
+
+        for(int i = 0; i < 10; i++)
+        {
+            int xf = x + rand.nextInt(16);
+            int yf = rangeY / 2 + rand.nextInt(rangeY - 8) + 4;
+            int zf = z + rand.nextInt(16);
+            new WorldFeatureOre(Blocks.ORE_NETHERCOAL_NETHERRACK.id(), 12).place(world, rand, xf, yf, zf);
+        }
+
+        int max;
+        if (biome != Biomes.NETHER_ASH_PLAINS && biome != Biomes.NETHER_BONEYARD) {
+            max = rand.nextInt(rand.nextInt(10) + 1);
+            for(int i = 0; i < max; i++)
+            {
+                int xf = x + rand.nextInt(16) + 8;
+                int yf = world.getWorldType().getOceanY() + rand.nextInt(rangeY - 8) + 4;
+                int zf = z + rand.nextInt(16) + 8;
+                (new WorldFeatureFire()).place(world, rand, xf, yf, zf);
+            }
+        }
+
+        if (biome == Biomes.NETHER_BONEYARD) {
+            max = rand.nextInt(20) + 5;
+            for(int i = 0; i < max; i++)
+            {
+                int xf = x + rand.nextInt(16) + 8;
+                int yf = world.getWorldType().getOceanY() + rand.nextInt(rangeY - 8) + 4;
+                int zf = z + rand.nextInt(16) + 8;
+                (new WorldFeatureColdFire()).place(world, rand, xf, yf, zf);
+            }
+        }
+
+        max = rand.nextInt(rand.nextInt(10) + 1);
+        for(int i = 0; i < max; i++)
+        {
+            int xf = x + rand.nextInt(16) + 8;
+            int yf = world.getWorldType().getOceanY() + rand.nextInt(rangeY - 8) + 4;
+            int zf = z + rand.nextInt(16) + 8;
+            new WorldFeatureGlowstoneA().place(world, rand, xf, yf, zf);
+        }
+
+        for(int i = 0; i < 10; i++)
+        {
+            int xf = x + rand.nextInt(16) + 8;
+            int yf = world.getWorldType().getOceanY() + rand.nextInt(rangeY - 8) + 4;
+            int zf = z + rand.nextInt(16) + 8;
+            new WorldFeatureGlowstoneB().place(world, rand, xf, yf, zf);
+        }
+
+        if (biome != Biomes.NETHER_ASH_PLAINS && biome != Biomes.NETHER_BONEYARD) {
+            if (rand.nextInt(8) == 0) {
+                int xf = x + rand.nextInt(16) + 8;
+                int yf = rangeY / 2 + rand.nextInt(rangeY - 16) + 8;
+                int zf = z + rand.nextInt(16) + 8;
+                (new WorldFeatureLake(Blocks.FLUID_LAVA_STILL.id())).place(world, rand, xf, yf, zf);
+            }
+
+            for (int i = 0; i < /*20*/80; i++) {
+                int xf = x + rand.nextInt(16);
+                int yf = rangeY / 2 + rand.nextInt(rangeY);
+                int zf = z + rand.nextInt(16);
+                (new WorldFeaturePumice(32)).place(world, rand, xf, yf, zf);
+            }
+        }
+
+        int oceanY = world.getWorldType().getOceanY();
+        int midY = oceanY + (world.getWorldType().getMaxY() - oceanY) / 2;
+        for(int dx = x + 8; dx < x + 8 + 16; dx++)
+        {
+            for(int dz = z + 8; dz < z + 8 + 16; dz++)
+            {
+                int dy = midY;
+                while (world.getBlockId(dx, dy, dz) == 0) {
+                    dy--;
+                }
+                dy++;
+                Biome localBiome = world.getBlockBiome(dx, dy, dz);
+
+                if ((localBiome == Biomes.NETHER_ASH_PLAINS || localBiome == Biomes.NETHER_BONEYARD) && dy > 0 && dy < world.getHeightBlocks())
+                {
+                    if (world.isAirBlock(dx, dy, dz) && world.getBlockMaterial(dx, dy - 1, dz).blocksMotion() && world.getBlockId(dx, dy - 1, dz) != Blocks.OBSIDIAN.id())
+                    {
+                        world.setBlockWithNotify(dx, dy, dz, Blocks.LAYER_ASH.id());
+                    }
+                }
+            }
+
+        }
+
+
+        BlockLogicSand.fallInstantly = false;
+
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkGeneratorNether.java
index 25735df83..533a57c14 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkGeneratorNether.java
@@ -3,14 +3,24 @@ package net.minecraft.core.world.generate.chunk.perlin.nether;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.CavesLargeFeature;
 import net.minecraft.core.world.generate.LargeFeature;
+import net.minecraft.core.world.generate.NetherBonesLargeFeature;
 import net.minecraft.core.world.generate.WarrensCavesLargeFeature;
 import net.minecraft.core.world.generate.chunk.perlin.ChunkGeneratorPerlin;
 
 public class ChunkGeneratorNether
-    extends ChunkGeneratorPerlin
-{
-    public ChunkGeneratorNether(World world)
-    {
-        super(world, new ChunkDecoratorNether(world), new TerrainGeneratorNether(world), new SurfaceGeneratorNether(world), new LargeFeature[] { new CavesLargeFeature(128, 256), new WarrensCavesLargeFeature(0, 128) });
+    extends ChunkGeneratorPerlin {
+    public ChunkGeneratorNether(World world) {
+        super(
+            world,
+            new ChunkDecoratorNether(world),
+            new TerrainGeneratorNether(world),
+            new SurfaceGeneratorNether(world),
+            new LargeFeature[]
+                {
+                    new CavesLargeFeature(128, 256),
+                    new WarrensCavesLargeFeature(0, 128),
+                    new NetherBonesLargeFeature(128, 256)
+                }
+        );
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
index c455882a6..a709f569e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
@@ -1,18 +1,44 @@
 package net.minecraft.core.world.generate.chunk.perlin.nether;
 
+import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.biome.provider.BiomeProviderNether;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.perlin.DensityGenerator;
+import net.minecraft.core.world.noise.BasePerlinNoise;
 import net.minecraft.core.world.noise.PerlinNoise;
+import net.minecraft.core.world.noise.PerlinSimplexNoise;
+import net.minecraft.core.world.type.WorldType;
+
+import java.util.HashMap;
+import java.util.Map;
+import java.util.Random;
 
 public class DensityGeneratorNether
     implements DensityGenerator
 {
+    private interface BiomeDensityGenerator {
+        double[] generateDensityMap(Chunk chunk, int terrainHeight, int xSize, int ySize, int zSize, int x, int y, int z);
+    }
+
     private final World world;
 
     private final PerlinNoise minLimitNoise;
     private final PerlinNoise maxLimitNoise;
     private final PerlinNoise mainNoise;
+    private final PerlinNoise scaleNoise;
+    private final PerlinNoise depthNoise;
+
+    private final PerlinSimplexNoise poolNoiseOver;
+    private final PerlinSimplexNoise poolNoiseUnder;
+
+    private final PerlinSimplexNoise ravineNoise2;
+
+    private final PerlinSimplexNoise islandNoise;
+
+    private final Map<Biome, BiomeDensityGenerator> densityGeneratorMap = new HashMap<>();
 
     public DensityGeneratorNether(World world)
     {
@@ -21,21 +47,96 @@ public class DensityGeneratorNether
         this.minLimitNoise = new PerlinNoise(world.getRandomSeed(), 16, 0);
         this.maxLimitNoise = new PerlinNoise(world.getRandomSeed(), 16, 16);
         this.mainNoise = new PerlinNoise(world.getRandomSeed(), 8, 32);
+        this.scaleNoise = new PerlinNoise(world.getRandomSeed(), 10, 48);
+        this.depthNoise = new PerlinNoise(world.getRandomSeed(), 16, 58);
+
+        Random rand = new Random(world.getRandomSeed());
+
+        this.islandNoise = new PerlinSimplexNoise(rand, 6);
+        this.ravineNoise2 = new PerlinSimplexNoise(rand, 4);
+
+        this.poolNoiseOver = new PerlinSimplexNoise(rand, 4);
+        this.poolNoiseUnder = new PerlinSimplexNoise(rand, 1);
+
+        densityGeneratorMap.put(Biomes.NETHER_NETHER, this::generateDensityMapBiomeNether);
+        densityGeneratorMap.put(Biomes.NETHER_VOLCANIC_ISLANDS, this::generateDensityMapBiomeVolcanicIslands);
+        densityGeneratorMap.put(Biomes.NETHER_SULFUR_POOLS, this::generateDensityMapBiomeSulphurPools);
+        densityGeneratorMap.put(Biomes.NETHER_CRYSTAL_FOREST, this::generateDensityMapOcean);
+        densityGeneratorMap.put(Biomes.NETHER_ASH_PLAINS, this::generateDensityMapBiomeTest);
+        densityGeneratorMap.put(Biomes.NETHER_BONEYARD, this::generateDensityMapBiomeTest);
     }
 
     @Override
     public double[] generateDensityMap(Chunk chunk)
     {
-        int terrainHeight = (world.getWorldType().getMaxY() + 1) - world.getWorldType().getMinY();
-        int halfTerrainHeight = terrainHeight / 2;
+        WorldType worldType = world.getWorldType();
+
+        int terrainHeight = ((worldType.getMaxY() + 1) - worldType.getMinY());
         int xSize = 4 + 1;
         int ySize = (terrainHeight / 8) + 1;
-        int halfYSize = (halfTerrainHeight / 8) + 1;
         int zSize = 4 + 1;
         int x = chunk.xPosition * 4;
         int y = 0;
         int z = chunk.zPosition * 4;
 
+        int halfYSize = ((terrainHeight / 2) / 8) + 1;
+
+        double[] densityMapArray = new double[xSize * ySize * zSize];
+        Map<Biome, double[]> perBiomeDensityMaps = new HashMap<>();
+
+        BiomeProviderNether biomeProvider = (BiomeProviderNether) world.getBiomeProvider();
+        BiomeProviderNether.BiomeOverlapPair[] overlapPairs = new BiomeProviderNether.BiomeOverlapPair[xSize * zSize];
+
+        // Cache density maps for biome(s)
+        int xSizeScale = 16 / xSize;
+        for (int dx = 0; dx < xSize; dx++) {
+            int ix = dx * xSizeScale + xSizeScale / 2;
+            for (int dz = 0; dz < zSize; dz++) {
+                int iz = dz * xSizeScale + xSizeScale / 2;
+                double temperature = chunk.temperature[ix * 16 + iz];
+                BiomeProviderNether.BiomeOverlapPair overlapPair = overlapPairs[dx * xSize + dz] = new BiomeProviderNether.BiomeOverlapPair();
+                biomeProvider.getOverlap(temperature, overlapPair);
+
+                if (!perBiomeDensityMaps.containsKey(overlapPair.biomeA)) {
+                    perBiomeDensityMaps.put(overlapPair.biomeA, densityGeneratorMap.get(overlapPair.biomeA).generateDensityMap(chunk, terrainHeight / 2, xSize, halfYSize, zSize, x, y, z));
+                }
+                if (overlapPair.hasOverlap) {
+                    if (!perBiomeDensityMaps.containsKey(overlapPair.biomeB)) {
+                        perBiomeDensityMaps.put(overlapPair.biomeB, densityGeneratorMap.get(overlapPair.biomeB).generateDensityMap(chunk, terrainHeight / 2, xSize, halfYSize, zSize, x, y, z));
+                    }
+                }
+            }
+        }
+
+        // Merge density maps
+        for (int dx = 0; dx < xSize; dx++) {
+            for (int dz = 0; dz < zSize; dz++) {
+                BiomeProviderNether.BiomeOverlapPair overlapPair = overlapPairs[dx * xSize + dz];
+                double[] densityMapA = perBiomeDensityMaps.get(overlapPair.biomeA);
+                double[] densityMapB = null;
+                if (overlapPair.hasOverlap) {
+                    densityMapB = perBiomeDensityMaps.get(overlapPair.biomeB);
+                }
+
+                if (densityMapB != null) {
+                    for (int dy = 0; dy < halfYSize; dy++) {
+                        double densityA = densityMapA[(dx * zSize * halfYSize) + (dz * halfYSize) + dy];
+                        double densityB = densityMapB[(dx * zSize * halfYSize) + (dz * halfYSize) + dy];
+                        densityMapArray[(dx * zSize * ySize) + (dz * ySize) + (dy + halfYSize - 1)] = MathHelper.lerp(densityA, densityB, overlapPair.biomeBPercentage);
+                    }
+                } else {
+                    for (int dy = 0; dy < halfYSize; dy++) {
+                        double densityA = densityMapA[(dx * zSize * halfYSize) + (dz * halfYSize) + dy];
+                        densityMapArray[(dx * zSize * ySize) + (dz * ySize) + (dy + halfYSize - 1)] = densityA;
+                    }
+                }
+            }
+        }
+
+        return densityMapArray;
+    }
+
+    private double[] generateDensityMapBiomeNether(Chunk chunk, int terrainHeight, int xSize, int ySize, int zSize, int x, int y, int z) {
         double[] densityMapArray = new double[xSize * ySize * zSize];
 
         final double mainNoiseScaleX = 80.0;
@@ -48,17 +149,18 @@ public class DensityGeneratorNether
         final double upperLimitScale = 512.0;
         final double lowerLimitScale = 512.0;
 
-        double[] mainNoiseArray = mainNoise.get(null, x, y, z, xSize, halfYSize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
-        double[] minLimitArray = minLimitNoise.get(null, x, y, z, xSize, halfYSize, zSize, coordScale, heightScale, coordScale);
-        double[] maxLimitArray = maxLimitNoise.get(null, x, y, z, xSize, halfYSize, zSize, coordScale, heightScale, coordScale);
-        double[] densityOffsetArray = new double[halfYSize];
-        for(int dy = 0; dy < halfYSize; dy++)
+        double[] mainNoiseArray = mainNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
+        double[] minLimitArray = minLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] maxLimitArray = maxLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        int mainIndex = 0;
+        double[] densityOffsetArray = new double[ySize];
+        for(int dy = 0; dy < ySize; dy++)
         {
-            densityOffsetArray[dy] = Math.cos(((double)dy * Math.PI * 6D) / (double)halfYSize) * 2D;
+            densityOffsetArray[dy] = Math.cos(((double)dy * Math.PI * 6D) / (double)ySize) * 2D;
             double densityOffset = dy;
-            if(dy > halfYSize / 2)
+            if(dy > ySize / 2)
             {
-                densityOffset = halfYSize - 1 - dy;
+                densityOffset = ySize - 1 - dy;
             }
             if(densityOffset < 4D)
             {
@@ -71,16 +173,13 @@ public class DensityGeneratorNether
         {
             for(int dz = 0; dz < zSize; dz++)
             {
-                for(int dy = 0; dy < halfYSize; dy++)
+                for(int dy = 0; dy < ySize; dy++)
                 {
-                    int halfIndex = (dx * halfYSize * zSize) + (dz * halfYSize) + dy;
-                    int offsetIndex = (dx * ySize * zSize) + (dz * ySize) + (dy + halfYSize - 1);
-
                     double density;
                     double densityOffset = densityOffsetArray[dy];
-                    double minDensity = minLimitArray[halfIndex] / upperLimitScale;
-                    double maxDensity = maxLimitArray[halfIndex] / lowerLimitScale;
-                    double mainDensity = (mainNoiseArray[halfIndex] / 10D + 1.0D) / 2D;
+                    double minDensity = minLimitArray[mainIndex] / upperLimitScale;
+                    double maxDensity = maxLimitArray[mainIndex] / lowerLimitScale;
+                    double mainDensity = (mainNoiseArray[mainIndex] / 10D + 1.0D) / 2D;
 
                     // Constrain density
                     if(mainDensity < 0.0D)
@@ -97,13 +196,14 @@ public class DensityGeneratorNether
                     }
                     density -= densityOffset;
 
-                    if(dy > halfYSize - 4)
+                    if(dy > ySize - 4)
                     {
-                        double d11 = (float)(dy - (halfYSize - 4)) / 3F;
-                        density = density * (1.0D - d11) + -10D * d11;
+                        double densityMod = (float)(dy - (ySize - 4)) / 3F;
+                        density = density * (1.0D - densityMod) + -10D * densityMod;
                     }
 
-                    densityMapArray[offsetIndex] = density;
+                    densityMapArray[mainIndex] = density;
+                    mainIndex++;
                 }
 
             }
